/**
 * Created by GuanYuAnAn on 2018/4/2.
 */


//区分是否android和ios方法
var u = navigator.userAgent, app = navigator.appVersion;
var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1; //android终端或者uc浏览器
var isIos = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端

//  封装时间日期转换方法 js由毫秒数得到年月日   使用： (new Date(data[i].creationTime)).Format("yyyy-MM-dd hh:mm:ss.S")
Date.prototype.Format = function (fmt) {
    var o = {
        "M+": this.getMonth() + 1, //月份
        "d+": this.getDate(), //日
        "h+": this.getHours(), //小时
        "m+": this.getMinutes(), //分
        "s+": this.getSeconds(), //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
};


//请求接口地址分布配置
var allServer = {
    zs: 'https://api.shangbangup.top',
 cs: 'https://testapi.shangbangup.top'
    //cs: 'http://112.126.96.118'

};
var testServer = allServer.zs;


//截取url方法获得截取的参数
function getUrl(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
    var r = window.location.search.substr(1).match(reg);
    if (r != null) return unescape(r[2]);
    return "";
}

//新闻详情 视频详情
var token = getUrl('token');  //截取token userLogin必传值
var newsId = getUrl('newsId');//截取新闻详情页newsId参数
var videoId = getUrl('videoId');//截取视频详情页videoId参数
var channelId = getUrl('channelId');//截取新闻详情页channelId参数
var channelName = decodeURI(getUrl('channelName'));//截取新闻详情页channelName参数
var isCheck = getUrl('isCheck');//是否审核中 广告是否显示
var isExamine = getUrl('isExamine');//ios审核参数 0审核前/1审核后 控制部分样式的隐藏展示

//邀请页
var entrance = getUrl('entrance');//從哪裡進入發邀請的頁面
var types = getUrl('type');//打開邀請三頁的哪一頁
var isPush = getUrl('isPush');//是否開啟推送

//提现流程
var mode = getUrl('mode');//提現方式
var moneys = getUrl('moneys');//提現金額
var yzm = getUrl('yzm');//提現驗證碼
var loginPhone = getUrl('loginPhone');//提現user手機號
var account = getUrl('account');//提現用戶賬戶

//站外下載
var inviteType = getUrl('inviteType');
var userName = getUrl('userName');
var from = getUrl('from');
var pMark = getUrl('pMark');
var money = getUrl('money');
var pid = getUrl('pid');

//封裝年月日時分秒
var date = new Date();
var time = getNowFormatDate(date);

function getNowFormatDate(date) {
    var seperator1 = "-";
    var seperator2 = ":";
    var hours = date.getHours();
    var getMinutes = date.getMinutes();
    var getSeconds = date.getSeconds();
    var month = date.getMonth() + 1;
    var strDate = date.getDate();
    if (month >= 1 && month <= 9) {
        month = "0" + month;
    }
    if (strDate >= 0 && strDate <= 9) {
        strDate = "0" + strDate;
    }
    if (hours >= 0 && hours <= 9) {
        hours = "0" + hours;
    }
    if (getMinutes >= 0 && getMinutes <= 9) {
        getMinutes = "0" + getMinutes;
    }
    if (getSeconds >= 0 && getSeconds <= 9) {
        getSeconds = "0" + getSeconds;
    }
    var currentdate = date.getFullYear() + seperator1 + month + seperator1 + strDate
        + " " + hours + seperator2 + getMinutes
        + seperator2 + getSeconds;
    return currentdate;
}

//关闭弹层
function closeContoner() {
    $('.bigAlertBox').hide();
    $('.alertShowOpen').hide();
}


//    埋点 /task/tracker
function trackerAll(pageCate, pageId, jumpType, refPageId, area, index, extKeyword, extTaskId) {
    var queryString = {
        pageCate: pageCate,//分类
        pageId: pageId,//埋点id
        jumpType: jumpType,//1.普通跳转 2.普通不跳转
        refPageId: refPageId,//跳转到埋点id
        tapArea: area,//h5 tap 点击区域
        tapIndex: index,//h5 tap 第几个
        extKeyword: extKeyword,//关键字 比如:新闻详情页加载速度20ms.
        extTaskId: extTaskId//任务id 比如:宝箱任务等
    };
    try {
        getTrackerInfo(queryString);
    } catch (e) {
        console.log('暂缓开通');
    }
}


//封装公用ajax请求方式
// function guanYuAnAn(inName, flagYnc, fromAndroid, clienHeader, succFn) {
//     alert(clienHeader);
//     $.ajax({
//         type: "post",
//         // contentType : "application/json;charset=UTF-8",
//         url: testServer + inName,
//         timeout: 10000,
//         async: flagYnc,
//         dataType: "jsonp",
//         headers: JSON.parse(clienHeader),
//         data: fromAndroid,
//         success: succFn,
//         error:function (err) {
//             console.log(JSON.stringify(err))
//         }
//     });
// };


// function guanYuAnAn(inName, flagYnc, fromAndroid, clienHeader) {
//     var xhr = new XMLHttpRequest();
//     xhr.open("POST", testServer + inName, flagYnc);
//     xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");
//     var headers = JSON.parse(clienHeader);
//     for (var k in headers) {
//         xhr.setRequestHeader(k, headers[k]);
//     }
//     xhr.onreadystatechange = function () {
//         if (xhr.readyState == 4 && xhr.status >= 200 && xhr.status < 300) {
//             var res = JSON.parse(xhr.responseText);
//
//         }
//     };
//     xhr.send(fromAndroid);
// }


/* 封装ajax函数
 * @param {string}opt.type http连接的方式，包括POST和GET两种方式
 * @param {string}opt.url 发送请求的url
 * @param {boolean}opt.async 是否为异步请求，true为异步的，false为同步的
 * @param {function}opt.success ajax发送并接收成功调用的回调函数
 * @param {object}opt.data 发送的参数，格式为对象类型
 * @param {function}pre.headers 请求头客户端返回
 * @param {function}opt.clienHeader 请求头客户端返回
 * @param {function}pre.method 请求客户端的getSign
 * @param {function}pre.data 客户端返回加密后数据
 */

// var app2HtmlHandlers = {};
//
// function app2Html(context,reD, reH) {
//     app2HtmlHandlers[context](reD, reH);
// }
//
//
// ajaxHttps({
//     'params':{}//pre
// });


function ajaxHttps(pre, opt) {
    pre = pre || {};
    pre.method = 'getSign';
    pre.params = pre.params || null;
    // pre.callback = aa;
    pre.context = Math.random()+"@"+Math.random();
    app2HtmlHandlers[context_key] = function(reD, reH){
        opt.data = reD;
        opt.headers = reH;
        opt = opt || {};
        opt.method = opt.method.toUpperCase() || 'POST';
        opt.url = opt.url || '';
        opt.async = opt.async || true;
        opt.data = pre.data || null;
        opt.success = opt.success || function () {
        };
        var xmlHttp = null;
        if (XMLHttpRequest) {
            xmlHttp = new XMLHttpRequest();
        }
        else {
            xmlHttp = new ActiveXObject('Microsoft.XMLHTTP');
        }
        var params = [];
        for (var key in opt.data) {
            params.push(key + '=' + opt.data[key]);
        }
        var postData = params.join('&');
        if (opt.method.toUpperCase() === 'POST') {
            xmlHttp.open(opt.method, opt.url, opt.async);
            xmlHttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded;charset=utf-8');

            var headers = JSON.parse(opt.headers);
            for (var k in headers) {
                xhr.setRequestHeader(k, headers[k]);
            }
            xmlHttp.send(postData);
        }
        else if (opt.method.toUpperCase() === 'GET') {
            xmlHttp.open(opt.method, opt.url + '?' + postData, opt.async);
            xmlHttp.send(null);
        }
        xmlHttp.onreadystatechange = function () {
            if (xmlHttp.readyState == 4 && xmlHttp.status == 200) {
                opt.success(xmlHttp.responseText);
            }
        };
    };
    isAndroid ? window.qknewsjs.getSign(JSON.stringify(pre)) : null;
    isIos ? window.webkit.messageHandlers.getSign.postMessage(JSON.stringify(pre)) : null;
}


// function guanYuAnAn(inName, flagYnc, fromAndroid, clienHeader, fnSuc) {
//     $.ajax({
//         async: flagYnc,
//         type: "post",
//         contentType: "application/json;charset=UTF-8", //类型必填
//         url: testServer + inName,
//         headers:fromAndroid,
//         data: fromAndroid,
//         dataType: "jsonp",
//         success: fnSuc,
//         error: function (err) {
//             console.log(JSON.stringify(err))
//         }
//     })
// }


//封装sign入参加密
function interactive(data, nameFn) {
    var btnDateForJava = {
        'method': 'getSign',
        'params': data,
        'callBack': nameFn
    };
    if (isAndroid) {
        window.qknewsjs.getSign(JSON.stringify(btnDateForJava));
    } else if (isIos) {
        window.webkit.messageHandlers.getSign.postMessage(JSON.stringify(btnDateForJava));
    }
}

//封装埋点获取入参
function getTrackerInfo(data) {
    var btnDateForJava = {
        'method': 'getTrackerInfo',
        'params': data
    };
    if (isAndroid) {
        window.qknewsjs.getTrackerInfo(JSON.stringify(btnDateForJava));
    } else if (isIos) {
        window.webkit.messageHandlers.getTrackerInfo.postMessage(JSON.stringify(btnDateForJava));
    }
}


//封装获取邀请码方法
function forInviteCode(getCodeFn) {
    var queryStr = {
        'method': 'getInviteCode',
        'params': {},
        'callBack': getCodeFn
    };
    if (isAndroid) {
        window.qknewsjs.getInviteCode(JSON.stringify(queryStr));
    } else if (isIos) {
        window.webkit.messageHandlers.getInviteCode.postMessage(JSON.stringify(queryStr));
    }
}

//封装获取师傅信息方法
function ForWorkerInfo(getWorkerInfoFn) {
    var queryStr = {
        'method': 'getWorkerInfo',
        'params': {},
        'callBack': getWorkerInfoFn
    };
    if (isAndroid) {
        window.qknewsjs.getWorkerInfo(JSON.stringify(queryStr));
    } else if (isIos) {
        window.webkit.messageHandlers.getWorkerInfo.postMessage(JSON.stringify(queryStr));
    }
}

//获取余额信息
function forMoneyInfo(getMoneyInfo) {
    var queryStr = {
        'method': 'getMoneyInfo',
        'params': {},
        'callBack': getMoneyInfo
    };
    if (isAndroid) {
        window.qknewsjs.getMoneyInfo(JSON.stringify(queryStr));
    } else if (isIos) {
        window.webkit.messageHandlers.getMoneyInfo.postMessage(JSON.stringify(queryStr));
    }
}

//任务中心获取用户是否绑定了手机号来判断按钮是否隐藏掉
function userBind(isBind) {
    var queryStr = {
        'method': 'userBind',
        'params': {},
        'callBack': isBind
    };
    if (isAndroid) {
        window.qknewsjs.userBind(JSON.stringify(queryStr));
    } else if (isIos) {
        window.webkit.messageHandlers.userBind.postMessage(JSON.stringify(queryStr));
    }

    /*
    * url api地址
    * params ajax请求参数
    * clientHeader ajax请求头设置
    * callBack 请求回调方法
    * */
    function difineFetchPost(url, params, clientHeader, callBack) {
        var xhr = new XMLHttpRequest();
        xhr.open("POST", testServer + url, false);
        xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");
        var headers = JSON.parse(clientHeader);
        console.log(headers, 'headers') 
        for (var k in headers) {
            if (k === 'market' && !headers[k]) {
                xhr.setRequestHeader('market', 'hongbaohezi');
            }else {
                xhr.setRequestHeader(k, headers[k]);
            }
        }
        console.log(xhr.readyState, 'xhr.readyState')
        console.log(xhr.status, 'xhr.status')
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4 && xhr.status >= 200 && xhr.status < 300) {
                var res = JSON.parse(xhr.responseText);
                if (res.code === 1) {
                    callBack(res);
                } else {
                    if (res.is_show == 1) {
                        showMessage(res.message, 3000, true, '', '')
                    }
                }
            }
        }
        xhr.send(params);
    }
}
